#include <stdio.h>
#include <string.h>

void print_mem_hex(const char *str, unsigned char *addr, size_t length)
{
	int i = 0;
	printf(str);
	for (i = 0; i < length; i++)
		printf("%.2x ", addr[i]);
	printf("\n");
}

int main (int argc, char *argv[])
{
	char buffer[0x20] = { 42 };

	printf("buffer is located at %p\n", buffer);

	if (argc < 2) {
		printf("No args, bail out\n");
		return 0;
	}

	printf("Return address = %p & frame address = %p\n", __builtin_return_address(0), __builtin_frame_address(0));
	print_mem_hex("Ret addr = ", buffer + sizeof(buffer) + 12, sizeof(char*));
	strcpy(buffer, argv[1]);
	printf("Return address = %p & frame address = %p\n", __builtin_return_address(0), __builtin_frame_address(0));

	return 0;
}
